﻿package

{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	
	

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		
		private var cur:Number;
		private var rot:Number;
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 1000;
			fibonacci	= 1/3334;
			accident	= 100.998;
			rapport 	= 360-360*accident -55;
			rad 		= 42;
			growth		= 1.005;
			sc_x		= 1;
			sc_y		= 7;
			rpx			= 180;
			rpy			= 1.018;
		
			cur			= max;
			rot			= 180;
		}
		
		private function addedHandler(e:Event):void
		{
			//addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			//stage.addEventListener(MouseEvent.CLICK, clickHandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downhandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, uphandler);
			
		}
	
		
		
		private function downhandler(e:MouseEvent):void
		{ 
			addEventListener(Event.ENTER_FRAME,enterhandler);

			}
			
		private function uphandler(e:MouseEvent):void
		{
			//removeEventListener(MouseEvent.MOUSE_DOWN,downhandler);
			removeEventListener(Event.ENTER_FRAME,enterhandler)
			}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			//removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
		}
		
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				//rapport*=accident;
				sc_x*=rpx+rpy;
				sc_y*=rpy;
				rot += rapport;
				rot-= new int(rot/360)*360;
				rad*=growth;
				var x:Number = mouseX+Math.cos(rot * Math.PI/180) *rad;
				var y:Number = mouseY+Math.sin(rot * Math.PI/180) *rad;
				if(cur!= (max-1)){
					graphics.lineStyle(1,0xff77ff,.15);
					graphics.lineTo(x,y);
					graphics.drawRect(mouseX,mouseY,2,2);
					graphics.drawCircle(mouseX,mouseY,5);
					graphics.lineTo(mouseX,mouseY);
				}else{
					graphics.moveTo(x,y);
					//graphics.drawCircle(mouseX,mouseY,2);
					
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}